/* VirtueMart mapped fields */
INSERT IGNORE INTO `#__csvi_mappedfields` (`field_virtuemart`, `field_hikashop`, `field_j2store`)
VALUES
/* Product fields */
('product_sku', 'product_code', 'sku'),
('product_price', 'product_price', 'price'),
('category_id', 'category_id', 'category_id'),
('category_path', 'category_path', 'category_path'),
('category_name', 'category_name', ''),
('product_parent_sku', 'product_parent_code', ''),
('product_name', 'product_name', 'title'),
('product_s_desc', '', 'introtext'),
('product_desc', 'product_description', 'fulltext'),
('picture_url_thumb', 'picture_url_thumb', ''),
('manufacturer_name', 'brand', 'manufacturer_name'),
('file_url', 'file_path', 'main_image'),
('picture_url', 'file_path', 'main_image'),
('file_url_thumb', '', 'thumb_image'),
('file_ordering', 'file_ordering', ''),
('file_title', 'file_name', 'main_image_alt'),
('file_description', 'file_description', ''),
('related_products', 'related_products', ''),
('product_tax', 'product_tax', ''),
('price_with_tax', 'price_with_tax', ''),
('product_weight', 'product_weight', 'weight'),
('product_width', 'product_width', 'width'),
('product_length', 'product_length', 'length'),
('product_in_stock', 'product_quantity', 'quantity'),
('product_height', 'product_height', 'height'),
('product_currency', 'currency_code', ''),
('product_availability', '', 'availability'),
('max_order_level', 'product_max_per_order', ''),
('min_order_level', 'product_min_per_order', ''),
('price_quantity_start', 'price_min_quantity', ''),
('product_gtin', 'gtin', ''),
('product_alias', 'slug', 'alias'),
('published', 'product_published', 'enabled'),
('product_weight_uom', 'product_weight_unit', ''),
('product_lwh_uom', 'product_dimension_unit', ''),
/* Category fields */
('category_name', 'category_path', ''),
('category_path', 'category_path', ''),
('category_description', 'category_description', ''),
('category_layout', 'category_layout', ''),
('published', 'category_published', ''),
('file_url', 'file_path', ''),
('file_title', 'file_name', ''),
('file_description', 'file_description', ''),
('file_ordering', 'file_ordering', ''),
('created_on', 'category_created', ''),
('modified_on', 'category_modified', ''),
('ordering', 'category_ordering', ''),
('metadesc', 'category_meta_description', ''),
/* Users fields*/
('address_1', 'address_street', 'address_1'),
('address_2', 'address_street2', 'address_2'),
('address_type', 'address_type', 'type'),
('city', 'address_city', 'city'),
('company', 'address_company', 'company'),
('country_2_code', 'country_2_code', 'country_isocode_2'),
('country_3_code', 'country_3_code', 'country_isocode_3'),
('country_name', 'country_name', 'country_name'),
('email', 'email', 'email'),
('fax', 'address_fax', 'fax'),
('first_name', 'address_firstname', 'first_name'),
('full_name', 'name', ''),
('last_name', 'address_lastname', 'last_name'),
('lastvisitDate', 'lastvisitDate', ''),
('lastResetTime', 'lastResetTime', ''),
('middle_name', 'address_middle_name', ''),
('name', 'name', ''),
('phone_1', 'address_telephone', 'phone_1'),
('phone_2', 'address_telephone2', 'phone_2'),
('state_3_code', 'state_3_code', 'zone_code'),
('state_name', 'state_name', 'zone_name'),
('title', 'address_title', ''),
('usergroup_name', 'usergroup_name', ''),
('username', 'username', ''),
('zip', 'address_post_code', 'zip'),
/* Price fields*/
('product_price', 'price_value', 'price'),
('product_sku', 'product_code', 'sku'),
('price_quantity_start', 'price_min_quantity', ''),
('product_currency', 'currency_code', ''),
('shopper_group_name', 'price_access', 'customer_group_name'),
('product_price_publish_up', 'price_start_date', 'date_from'),
('product_price_publish_down', 'price_end_date', 'date_to'),
('price_quantity_start', '', 'quantity_from'),
('price_quantity_end', '', 'quantity_to'),
/* Order fields*/
('billing_address_1', 'billing_address_street', 'billing_address_1'),
('billing_address_2', 'billing_address_street2', 'billing_address_2'),
('billing_city', 'billing_address_city', 'billing_city'),
('billing_company', 'billing_address_company', 'billing_company'),
('billing_country_2_code', 'billing_country_zone_code_2', ''),
('billing_country_3_code', 'billing_country_zone_code_3', ''),
('billing_country_name', 'billing_address_country', 'billing_country_name'),
('billing_fax', 'billing_address_fax', 'billing_fax'),
('billing_first_name', 'billing_address_firstname', 'billing_first_name'),
('billing_last_name', 'billing_address_lastname', 'billing_last_name'),
('billing_middle_name', 'billing_address_middle_name', 'billing_middle_name'),
('billing_phone_1', 'billing_address_telephone', 'billing_phone_1'),
('billing_phone_2', 'billing_address_telephone2', 'billing_phone_2'),
('billing_state_2_code', 'billing_state_zone_code_2', ''),
('billing_state_3_code', 'billing_state_zone_code_3', ''),
('billing_state_name', 'billing_state_zone_name_english', 'billing_zone_name'),
('billing_title', 'billing_address_title', ''),
('billing_fax', 'billing_address_fax', 'billing_fax'),
('billing_zip', 'billing_address_post_code', 'billing_zip'),
('invoice_number', 'order_invoice_number', 'invoice_number'),
('shipping_address_1', 'shipping_address_street', 'shipping_address_1'),
('shipping_address_2', 'shipping_address_street2', 'shipping_address_2'),
('shipping_city', 'shipping_address_city', 'shipping_city'),
('shipping_company', 'shipping_address_company', 'shipping_company'),
('shipping_country_2_code', 'shipping_country_zone_code_2', ''),
('shipping_country_3_code', 'shipping_country_zone_code_3', ''),
('shipping_country_name', 'shipping_country_zone_name_english', 'shipping_country_name'),
('shipping_fax', 'shipping_address_fax', 'shipping_fax'),
('shipping_first_name', 'shipping_address_firstname', 'shipping_first_name'),
('shipping_last_name', 'shipping_address_lastname', 'shipping_last_name'),
('shipping_middle_name', 'shipping_address_middle_name', 'shipping_middle_name'),
('shipping_phone_1', 'shipping_address_telephone', 'shipping_phone_1'),
('shipping_phone_2', 'shipping_address_telephone2', 'shipping_phone_2'),
('shipping_state_2_code', 'shipping_state_zone_code_2', ''),
('shipping_state_3_code', 'shipping_state_zone_code_3', ''),
('shipping_state_name', 'shipping_state_zone_name_english', 'shipping_zone_name'),
('shipping_title', 'shipping_address_title', ''),
('shipping_zip', 'shipping_address_post_code', 'shipping_zip'),
('order_discountAmount', 'order_discount_price', 'order_discount'),
('order_total', 'order_full_price', 'order_total'),
('order_status', 'order_status', 'order_state'),
('order_currency', 'order_currency_info', 'currency_code'),
('order_language', 'order_lang', ''),
('order_payment', 'order_payment_price', ''),
('order_payment_tax', 'order_payment_tax', ''),
('order_shipment', 'order_shipping_price', 'order_shipping'),
('order_shipment_tax', 'order_shipping_tax', 'order_shipping_tax'),
('order_subtotal', '', 'order_subtotal'),
('order_tax', 'order_tax_info', 'order_tax'),
('ip_address', 'order_ip', 'ip_address'),
/*Order item fields*/
('order_item_currency', '', ''),
('order_item_name', 'order_product_name', 'orderitem_name'),
('order_item_sku', 'order_product_code', 'orderitem_sku'),
('product_item_price', 'order_product_price', 'orderitem_price'),
('product_quantity', 'order_product_quantity', 'orderitem_quantity'),
('product_tax', 'order_product_tax', 'orderitem_tax'),
('product_final_price', '', 'orderitem_finalprice'),
('product_subtotal_discount', '', 'orderitem_discount'),
('product_priceWithoutTax', '', 'orderitem_finalprice_without_tax');
