<?php
/**
 * @package     CSVI
 * @subpackage  HikaShop
 *
 * @author      RolandD Cyber Produksi <contact@rolandd.com>
 * @copyright   Copyright (C) 2006 - 2020 RolandD Cyber Produksi. All rights reserved.
 * @license     GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @link        https://rolandd.com
 */

defined('_JEXEC') or die;

jimport('joomla.form.helper');
JFormHelper::loadFieldClass('CsviForm');

/**
 * Select list form field with order product categories.
 *
 * @package     CSVI
 * @subpackage  HikaShop
 * @since       6.5.0
 */
class JFormFieldCsviHikashopOrderCategories extends JFormFieldCsviForm
{
	/**
	 * Type of field
	 *
	 * @var    string
	 * @since  6.5.0
	 */
	protected $type = 'CsviHikashopOrderCategories';

	/**
	 * Select categories.
	 *
	 * @return  array  An array of categories.
	 *
	 * @since   6.5.0
	 */
	protected function getOptions()
	{
		// Require the category handler
		require_once JPATH_PLUGINS . '/csviaddon/hikashop/com_hikashop/helper/com_hikashop_category.php';

		$helper = new Com_HikashopHelperCom_Hikashop_Category($this->db);
		$filter = array($this->db->quoteName('a.category_name', 'text'), $this->db->quoteName('a.category_id', 'value'));
		$options = $helper->getChildren('order', false, array(), '', false, false, false, $filter, true);

		if (empty($options))
		{
			$options = array();
		}

		return array_merge(parent::getOptions(), $options);
	}
}
