<?php
/**
 * @package     CSVI
 * @subpackage  HikaShop
 *
 * @author      RolandD Cyber Produksi <contact@rolandd.com>
 * @copyright   Copyright (C) 2006 - 2020 RolandD Cyber Produksi. All rights reserved.
 * @license     GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @link        https://rolandd.com
 */

defined('_JEXEC') or die;

jimport('joomla.form.helper');
JFormHelper::loadFieldClass('CsviForm');

/**
 * Select list form field with root categories.
 *
 * @package     CSVI
 * @subpackage  HikaShop
 * @since       6.0
 */
class JFormFieldCsviHikashopRootCategories extends JFormFieldCsviForm
{
	/**
	 * Type of field
	 *
	 * @var    string
	 * @since  4.0
	 */
	protected $type = 'CsviHikashopRootCategories';

	/**
	 * Select categories.
	 *
	 * @return  array  An array of users.
	 *
	 * @since   4.0
	 */
	protected function getOptions()
	{
		$query = $this->db->getQuery(true)
			->select($this->db->quoteName('category_id', 'value'))
			->select($this->db->quoteName('category_name', 'text'))
			->from($this->db->quoteName('#__hikashop_category'))
			->where($this->db->quoteName('category_parent_id') . ' = 1')
			->order($this->db->quoteName('category_ordering'));
		$this->db->setQuery($query);

		$options = $this->db->loadObjectList();

		return array_merge(parent::getOptions(), $options);
	}
}
