<?php
/**
 * @package     CSVI
 * @subpackage  HikaShop
 *
 * @author      RolandD Cyber Produksi <contact@rolandd.com>
 * @copyright   Copyright (C) 2006 - 2020 RolandD Cyber Produksi. All rights reserved.
 * @license     GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @link        https://rolandd.com
 */

defined('_JEXEC') or die;

jimport('joomla.form.helper');
JFormHelper::loadFieldClass('CsviForm');

/**
 * Select list form field for shipment.
 *
 * @package     CSVI
 * @subpackage  HikaShop
 * @since       7.10.0
 */
class CsvihikashopFormFieldOrdershipment extends JFormFieldCsviForm
{
	/**
	 * Type of field
	 *
	 * @var    string
	 * @since  7.10.0
	 */
	protected $type = 'OrderShipment';

	/**
	 * Get the options.
	 *
	 * @return  array  An array of shipping methods.
	 *
	 * @since   7.10.0
	 */
	protected function getOptions()
	{
		$query = $this->db->getQuery(true)
			->select(
				$this->db->quoteName(
					array(
						'hikashop_shipping.shipping_id',
						'hikashop_shipping.shipping_name'
					),
					array(
						'value',
						'text'
					)
				)
			)
			->from($this->db->quoteName('#__hikashop_shipping', 'hikashop_shipping'))
			->order($this->db->quoteName('text'))
			->group($this->db->quoteName('value'));

		$this->db->setQuery($query);
		$shipping = $this->db->loadObjectList();

		if (empty($shipping))
		{
			$shipping = array();
		}

		return array_merge(parent::getOptions(), $shipping);
	}
}
