<?php
/**
 * @package     CSVI
 * @subpackage  HikaShop
 *
 * @author      RolandD Cyber Produksi <contact@rolandd.com>
 * @copyright   Copyright (C) 2006 - 2020 RolandD Cyber Produksi. All rights reserved.
 * @license     GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @link        https://rolandd.com
 */

defined('_JEXEC') or die;

/**
 * The HikaShop category helper class for manufacturers.
 *
 * @package     CSVI
 * @subpackage  HikaShop
 * @since       6.0
 */
class Com_HikashopHelperCom_Hikashop_Category_Manufacturer extends Com_HikashopHelperCom_Hikashop_Category
{
	/**
	 * CSVI template helper
	 *
	 * @var    CsviHelperTemplate
	 * @since  6.0
	 */
	protected $template = null;

	/**
	 * CSVI log helper
	 *
	 * @var    CsviHelperLog
	 * @since  6.0
	 */
	protected $log = null;

	/**
	 * Constructor.
	 *
	 * @param   JDatabaseDriver  $db  Database connector.
	 *
	 * @throws  CsviException
	 *
	 * @since   4.0
	 */
	public function __construct(JDatabaseDriver $db)
	{
		parent::__construct($db);

		// Set the category separator
		if (is_null($this->categorySeparator))
		{
			$this->categorySeparator = '/';
		}
	}
}
