<?php
/**
 * @package     CSVI
 * @subpackage  K2
 *
 * @author      RolandD Cyber Produksi <contact@rolandd.com>
 * @copyright   Copyright (C) 2006 - 2020 RolandD Cyber Produksi. All rights reserved.
 * @license     GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @link        https://rolandd.com
 */

defined('_JEXEC') or die;

jimport('joomla.form.helper');
JFormHelper::loadFieldClass('CsviForm');

/**
 * K2 Extra fields list.
 *
 * @package     CSVI
 * @subpackage  K2
 * @since       6.0
 */
class JFormFieldCsviK2Groups extends JFormFieldCsviForm
{
	/**
	 * The type of field
	 *
	 * @var    string
	 * @since  6.0
	 */
	protected $type = 'CsviK2Groups';

	/**
	 * Specify the options to load.
	 *
	 * @return  array  A tree array.
	 *
	 * @since   6.0
	 */
	protected function getOptions()
	{
		$this->options = array();
		$query = $this->db->getQuery(true)
			->select($this->db->quoteName('id', 'value') . ',' . $this->db->quoteName('name', 'text'))
			->from($this->db->quoteName('#__k2_extra_fields_groups'));
		$this->db->setQuery($query);
		$this->options = $this->db->loadObjectList();

		return array_merge(parent::getOptions(), $this->options);
	}
}
