<?php
/**
 * @package     CSVI
 * @subpackage  K2
 *
 * @author      RolandD Cyber Produksi <contact@rolandd.com>
 * @copyright   Copyright (C) 2006 - 2020 RolandD Cyber Produksi. All rights reserved.
 * @license     GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @link        https://rolandd.com
 */

defined('_JEXEC') or die;

jimport('joomla.form.helper');
JFormHelper::loadFieldClass('CsviForm');

/**
 * Tags select list with K2 tags.
 *
 * @package     CSVI
 * @subpackage  K2
 * @since       6.4.0
 */
class JFormFieldCsviK2Tags extends JFormFieldCsviForm
{
	/**
	 * The type of field
	 *
	 * @var    string
	 * @since  6.4.0
	 */
	protected $type = 'CsviK2Tags';

	/**
	 * Specify the options to load.
	 *
	 * @return  array  tags array.
	 *
	 * @since   6.4.0
	 */
	protected function getOptions()
	{
		$this->options = array();

		if (class_exists('Com_k2HelperCom_k2'))
		{
			// Load the settings
			$jinput = JFactory::getApplication()->input;
			$template = new CsviHelperTemplate($jinput->get('id'));
			$settings = new CsviHelperSettings($this->db);
			$log = new CsviHelperLog($settings, $this->db);
			$fields = new CsviHelperFields($template, $log, $this->db);

			$helper = new Com_k2HelperCom_k2($template, $log, $fields, $this->db);
			$this->options = $helper->getItemTags();
		}

		return array_merge(parent::getOptions(), $this->options);
	}
}
